Subject: Re: [PATCH net-next 4/5] bonding: make Kconfig toggle to disable legacy interfaces

From: Stephen Hemminger <[email-masked]>
Date: Tue, 22 Sep 2020 17:01:19 -0700

On Tue, 22 Sep 2020 16:47:07 -0700
Jay Vosburgh <[email-masked]> wrote:

> Stephen Hemminger <[email-masked]> wrote:
> 
> >On Tue, 22 Sep 2020 09:37:30 -0400
> >Jarod Wilson <[email-masked]> wrote:
> >  
> >> By default, enable retaining all user-facing API that includes the use of
> >> master and slave, but add a Kconfig knob that allows those that wish to
> >> remove it entirely do so in one shot.
> >> 
> >> Cc: Jay Vosburgh <[email-masked]>
> >> Cc: Veaceslav Falico <[email-masked]>
> >> Cc: Andy Gospodarek <[email-masked]>
> >> Cc: "David S. Miller" <[email-masked]>
> >> Cc: Jakub Kicinski <[email-masked]>
> >> Cc: Thomas Davis <[email-masked]>
> >> Cc: [email-masked]
> >> Signed-off-by: Jarod Wilson <[email-masked]>  
> >
> >Why not just have a config option to remove all the /proc and sysfs options
> >in bonding (and bridging) and only use netlink? New tools should be only able
> >to use netlink only.  
> 
> 	I agree that new tooling should be netlink, but what value is
> provided by such an option that distros are unlikely to enable, and
> enabling will break the UAPI?
> 
> >Then you might convince maintainers to update documentation as well.
> >Last I checked there were still references to ifenslave.  
> 
> 	Distros still include ifenslave, but it's now a shell script
> that uses sysfs.  I see it used in scripts from time to time.

Some bleeding edge distros have already dropped ifenslave and even ifconfig.
The Enterprise ones never will.

The one motivation would be for the embedded folks which are always looking
to trim out the fat. Although not sure if the minimal versions of commands
in busybox are pure netlink yet.